function createCalibrationCapacitor(condname, x, y, dx, dy, R, p, Ex )
{

	dtx = dy;
	dty = dy;
	dt = 2*dy;
	q  = 0;
	Ey = 1;
	xprek = dtx/2;
	d  = R * p;
	d = d + 2*R + dx - 2 * xprek;
	zeroX = (2*x + dx + d)/2;
	zeroY = (y + 2.5*R);
	
	pl = jacob.createRectangleElement(condname  + "l" ,  x, y, dx, dy);
	condnamel = pl.getName();
	pl.setClosed( false );
	jacob.setVectorModifier(condnamel, "eforce", Ex, Ey, false);
	
	vvl = jacob.createRectangleElement(condname + "tl", x - dt - dtx,   y, dtx, dty);
	vvnamel = vvl.getName();
	mparticlel = jacob.createParticle(vvnamel, q,       x - dt - dtx/2, y + dty/2, 0, 0);
	mparticlel.setFixed(true);

	vil = jacob.createRectangleElement(condname + "vl", x - dtx/2,  y, dtx, dty);
	vinamel = vil.getName();
	vil.setClosed( false ); 
	jacob.setModifier(vinamel, "pargen");
	jacob.setVectorModifier(vinamel, "eforce", 2*Ex, 0.0, false);
	
	cl = jacob.createCircleElement(condname + "cl",     x + dx + R - xprek, y + dty/2, R);
	clname = cl.getName();
	cl.setClosed( false ); 

       
	x = x + d;
	pd = jacob.createRectangleElement(condname + "d", x, y, dx, dy);
	condnamed = pd.getName();
	pd.setClosed( false );
	jacob.setVectorModifier(condnamed, "eforce", Ex, Ey, false);

	vvd = jacob.createRectangleElement(condname +"td", x + dx + dt , y, dtx, dty);
	vvnamed = vvd.getName();
	mparticled = jacob.createParticle(vvnamed, q, x + dx + dt  + dtx/2, y + dty/2, 0, 0);
	mparticled.setFixed(true);

	vid = jacob.createRectangleElement(condname + "vd", x + dx - dtx/2,  y, dtx, dty);
	vinamed = vid.getName();
	vid.setClosed( false ); 
	jacob.setModifier(vinamed, "pargenneg");
	jacob.setVectorModifier(vinamed, "eforce", 2*Ex, 0.0, false);

	cd = jacob.createCircleElement(condname + "cd",    x  - R + xprek, y + dty/2, R);
	cDname = cd.getName();
	cd.setClosed( false ); 
	
	jacob.setProperty("debugName", "false");
	jacob.setProperty("debugChildCount", "true");
	jacob.setProperty("zeroX", zeroX);
	jacob.setProperty("zeroY", zeroY);

}

// createCalibrationCapacitor(condname, x, y, dx, dy, R, p )}
   createCalibrationCapacitor("c", 20, 220, 10, 10, 50, 2.5, 80);

