//----------------------------------------------------------------
// Jacob Lightening Model - Java script 
//----------------------------------------------------------------
R = 3;

randomweight = 0.2;         	// 0-1, 0 means no influence of random function to segments direction
fieldweight  = 1 - randomweight;// 0-1, 0 means no influence of external field
branchtreshold = 0.5;         	// 0-1, 0 means no branches ocurre
dbranchmin = 5*R;		// R-lengthbranch			

lengthbranch = 35;
lengthbar = lengthbranch;

NLEG = 100;
legforce = 10;
legcharge = 1;

x0 = 280;
y0 = 35;
x =  x0;
y =  y0;
xi = 25;
yi = 5;

Rb = R;
dd = R/2;

alpha0 = Math.PI/2;
alpha = alpha0;
delay = 100;

cloudCharge = 10;
rodeCharge = -50;
rodhouse = true;
ycloud = -20;
cfcharge = 2;

groundcharge = -2;
dxground = 500;
dyground = 4*R;
yground = 390;
npground = 5;
sleepground = 10;
//----------------------------------------------------------------
// Cloud element (flat)
//----------------------------------------------------------------
   cf = jacob.createRectangleElement("cf", x0-dxground/2, y0+ycloud, dxground, dyground);
   cf.setClosed( false );
   cfname = cf.getName();
//   jacob.setModifier(cfname, "parcon");
   jacob.createParticlesMesh("cf", cfcharge, x0-dxground/2+dd, y0+ycloud+dd, dxground-dd, dyground, (dxground-dd-dyground)/npground, true, sleepground, true);

//----------------------------------------------------------------
// Cloud element (circle)
//----------------------------------------------------------------
   c = jacob.createCircleElement("cloud", x0-xi*R, y0-yi*R, 3*R);
   jacob.createParticle("cloud", cloudCharge, x0-xi*R, y0-yi*R, true);

//----------------------------------------------------------------
// Ground element
//----------------------------------------------------------------
   g = jacob.createRectangleElement("ground", x0-dxground/2, y0+yground, dxground, dyground);
   g.setClosed( false );
   gname = g.getName();
   jacob.setModifier(gname, "parcon");
   jacob.createParticlesMesh("ground", groundcharge, x0-dxground/2+dd, y0+yground+dd, dxground-dd, dyground, (dxground-dd-dyground)/npground, true, sleepground, true);

//----------------------------------------------------------------
//  Ligtening rod element (House or cylinder)
//----------------------------------------------------------------
 if (rodhouse)
 {
  xh = x0 + 80;
  yh = y + yground;
  xhw = 10*R;
  yhh = 10*R;
  
   var xhpoints = new Array(xh, xh + xhw, xh + xhw, xh + xhw/2,   xh);
   var yhpoints = new Array(yh, yh, yh - yhh, yh - 1.5*yhh,   yh -yhh);

   h = jacob.createPolygonElement("house", xhpoints , yhpoints, 5);	
   h.setClosed( false );
   hname = h.getName();
   jacob.setModifier(hname, "parcon");
 //  jacob.setVectorModifier(hname, "setcharge", -1, -300, false);
   phr = jacob.createParticle(hname, rodeCharge, xh + xhw/2, yh - 1.5*yhh+R/2, false);
  }
  else
  {
   lr = jacob.createCircleElement("lr",x0+80,y+yground-yi*R,6*R);
   lr.setClosed( false );
   lrname = lr.getName();
   jacob.setModifier(lrname, "parcon");
   jacob.setVectorModifier(lrname, "setcharge", -1, -300, false);

   plr = jacob.createParticle(lrname, rodeCharge, x0+80, y+yground-5-6*R, false);
  }

//----------------------------------------------------------------
// initial element
//----------------------------------------------------------------
   c0 = jacob.createCircleElement("c0",x0-xi*R,y,R);
   c0.setClosed( false );
   c0name = c0.getName();
   p = jacob.createParticle(c0name,1,x0-xi*R,y,false);

//----------------------------------------------------------------
// initial variables
//----------------------------------------------------------------
   tcstar = "dummy";
   tcnov  = "dummy";

   cosa = 0.999;
   sina = Math.sqrt(1 - cosa * cosa);
   xleg = lengthbar*sina;
   yleg = lengthbar*cosa;
   branch = false;
   x = x0 - xi*R;
   y = y0 - 2*R;
   
   xstar = x;
   ystar = y;
   xnov = x;
   ynov = y;
   
   branchallowed = true;
   

//----------------------------------------------------------------
// Lightenig model main loop
//----------------------------------------------------------------
for (n = 0; n < NLEG; n++)
{
//----------------------------------------------------------------
// Ligtening segment
//----------------------------------------------------------------
        if (branch)        
          length = lengthbranch;
        else
          length = lengthbar;
        
	var xpoints = new Array(x - Rb*cosa, x + Rb*cosa, x + length*sina + Rb*cosa, x + length*sina - Rb*cosa);
	var ypoints = new Array(y + Rb*sina, y - Rb*sina, y + length*cosa - Rb*sina, y + length*cosa + Rb*sina);

	b = jacob.createPolygonElement("bar"+ n, xpoints , ypoints, 4);	
	b.setClosed( false );
	bname = b.getName();
	jacob.setVectorModifier(bname,"eforce", legforce*sina, legforce*cosa,false);
	
//----------------------------------------------------------------
// Segment's terminal element (circle) 
//----------------------------------------------------------------
        tcstar = tcnov;
        xstar = xnov;
        ystar = ynov;
        
        xtc = x + length*sina;
        ytc = y + length*cosa;
        tc = jacob.createCircleElement("t"+ n, xtc, ytc, R);
	tc.setClosed( false );
	tcname = tc.getName();
//	jacob.setModifier(tcname,"randomforce");
	tcnov = tcname;
	
	xnov = xtc;
	ynov = ytc;

	
//----------------------------------------------------------------
// Brench segment discharge; FIXME with various segment length!
//----------------------------------------------------------------	
	if (branch)
        {
	   jacob.scale(tcnov,1.0);
	   jacob.scale(tcstar,1.0);
	   jacob.moveBy(tcname, 0, 0, 1, delay, true );

	           xmove = jacob.getX(tcnov)- 2*R*sina;
	           ymove = jacob.getY(tcnov)- 2*R*cosa;
	   jacob.moveTo(tcstar, xmove, ymove);
	   jacob.moveBy(tcname, 0, 0, 1, delay, true );
       }
	
//----------------------------------------------------------------
// Discharge branch until particle meat terminal circle element 
//----------------------------------------------------------------	
	icount = 0;
//      while ((jacob.getParticleNumber(tcname) == 0) || (icount <= 100))
//      while (icount <= 10)
        while (jacob.getParticleNumber(tcname) == 0)
        {
            jacob.moveBy( tcname, 0, 0, 1, delay, true );
            icount++
        }
       
//----------------------------------------------------------------
// Considering electric field and random function 
//       - new segment angle calculation -
//----------------------------------------------------------------
            dbranch = 0;
            xleg = length*sina;
	    yleg = length*cosa;
//----------------------------------------------------------------
// Considering branch treshold probability 
//  - new segment position determination -
//----------------------------------------------------------------
       if (((Math.random() <= branchtreshold) && branchallowed) )
        {
          icount = 0;
           while ((dbranch <= dbranchmin))
           {
	     randfx =          (2*Math.random()-1);
	     randfy = Math.abs((2*Math.random()-1));
	        
	     Ex = jacob.getElementEx(tcname);
	     Ey = jacob.getElementEy(tcname);
		
	        ea = Math.sqrt(Ex*Ex + Ey*Ey);
		
      	    	if (ea==0)
	    	{			
	     	   cosa = 1;
	       	   sina = 0;
       	        }
	        else
	        {
	           sina = Ex/ea;
	           cosa = Ey/ea;
       	        }
		sina =  sina * fieldweight + randfx * randomweight;
		cosa =  cosa * fieldweight + randfy * randomweight;
		
		ea = Math.sqrt(cosa*cosa+sina*sina);		

	        sina /= ea;
	        cosa /= ea;
	        
	        xleg = length*sina;
	        yleg = length*cosa;

	        x += xleg;
	        y += yleg;
	        
	       icount++;

	    dbranch = Math.sqrt((xnov - x)*(xnov - x) + (ynov - y)*(ynov - y));
//----------------------------------------------------------------
// Discharge branch debug graphic tools 
//----------------------------------------------------------------

	    jacob.createCircleElement("t"+ icount, x-100, ystar, dbranch, false );
/*	    drod = Math.sqrt(xleg * xleg + yleg * yleg);
	    jacob.createCircleElement("y"+ icount, x-100, y, 4, false );
*/	      
	    x = xstar;
	    y = ystar;
	   }
	  branch = true;
	  branchallowed = false;
        }
	else     
	{
	     randfx =          (2*Math.random()-1);
	     randfy = Math.abs((2*Math.random()-1));
	        
	     Ex = jacob.getElementEx(tcname);
	     Ey = jacob.getElementEy(tcname);
		
	        ea = Math.sqrt(Ex*Ex + Ey*Ey);
		
      	    	if (ea==0)
	    	{			
	     	   cosa = 1;
	       	   sina = 0;
       	        }
	        else
	        {
	           sina = Ex/ea;
	           cosa = Ey/ea;
       	        }
		sina =  sina * fieldweight + randfx * randomweight;
		cosa =  cosa * fieldweight + randfy * randomweight;
		
		ea = Math.sqrt(cosa*cosa+sina*sina);		

	        sina /= ea;
	        cosa /= ea;
	                
	    x += xleg;
	    y += yleg;
	    branch = false;
	    branchallowed = true;

	}	
            xnov = x;
            ynov = y;
            
} // for main leg


// jacob.setProperty("elementBg", "#f582a9");
// pname = p.getName();
// jacob.setParticleModifier(pname,"randomforce");
// jacob.setVectorModifier(tcname,"eforce", legforce*sina, legforce*cosa,false);
